package com.despark.tuning3d.model.core {
    import com.despark.tuning3d.view.TuningScreenMediator;
    import com.despark.tuning3d.view.components.tunings.editing.TuningScreen;
    import com.despark.tuning3d.view.core.StackedScreenMediator;
    import com.distriqt.extension.firebase.crashlytics.FirebaseCrashlytics;

    public class ErrorTracker {
        private static var _stackedScreenMediator:StackedScreenMediator;
        private static var _lineLabel:String;
        public static function getMoreInfo(stackTrace:String = null):String{
            var result:String = '\n';
            switch (true) {
                case _stackedScreenMediator is TuningScreenMediator:
                    var tuningScreen:TuningScreen;
                    if(_stackedScreenMediator.stackedScreen){
                        tuningScreen = _stackedScreenMediator.stackedScreen as TuningScreen;
                    }
                    if(tuningScreen){
                        result += "TuningScreen:" + '\n';
                        if(tuningScreen.car){
                            FirebaseCrashlytics.service.setStringValue(tuningScreen.car.id, "carId");
                            FirebaseCrashlytics.service.setStringValue(tuningScreen.car.displayName, "carName");
                            result += "car: " + tuningScreen.car.id + '\n';
                        }
                        if(tuningScreen.selectedPartSlot){
                            FirebaseCrashlytics.service.setStringValue(tuningScreen.selectedPartSlot.name, "selectedPartSlot");
                            result += "selectedPartSlot: " + tuningScreen.selectedPartSlot.name + '\n';
                            if(tuningScreen.selectedPartSlot.selectedPart){
                                FirebaseCrashlytics.service.setStringValue(tuningScreen.selectedPartSlot.selectedPart.name, "carSelectedPart");
                                result += "carSelectedPart: " + tuningScreen.selectedPartSlot.selectedPart.name + '\n';
                                if(tuningScreen.selectedPartSlot.selectedPart.selectedMaterial){
                                    FirebaseCrashlytics.service.setStringValue(tuningScreen.selectedPartSlot.selectedPart.selectedMaterial.name, "selectedMaterial");
                                }
                            }
                        }
                        if(tuningScreen.selectedPart){
                            FirebaseCrashlytics.service.setStringValue(tuningScreen.selectedPart.name, "selectedPart");
                            FirebaseCrashlytics.service.setStringValue(tuningScreen.selectedPart.id, "selectedPartId");
                            result += "selectedPart: " + tuningScreen.selectedPart.name + '\n';
                        }
                        if(stackTrace && stackTrace.indexOf("tuningScreenPartSelectedHandler") != -1 && lineLabel){
                            FirebaseCrashlytics.service.setStringValue(lineLabel, "lineLabel");
                        }
                    }
                    break;
            }
            return result;
        }

        public static function setMediator(stackedScreenMediator:StackedScreenMediator):void{
            _stackedScreenMediator = stackedScreenMediator;
        }

        public static function setLineLabel(label:String):void{
            _lineLabel = label;
        }

        public static function get lineLabel():String {
            return _lineLabel;
        }
    }
}
