package com.utils {
    import com.distriqt.extension.firebase.crashlytics.FirebaseCrashlytics;

    public class JSONUtils {
        public static function parse(jsonClass:Class, text:String, reviver:Function = null, errorData:Object = null):Object{
            var result:Object;
            try{
                result = jsonClass.parse(text, reviver)
            }catch (e:Error) {
                result = {};
                FirebaseCrashlytics.service.recordError(e);
                FirebaseCrashlytics.service.setStringValue("parse", "function");
                FirebaseCrashlytics.service.setStringValue(text, "text");
                if(errorData){
                    for(var key:String in errorData){
                        FirebaseCrashlytics.service.setStringValue(key, errorData[key] as String);
                    }
                }
            }
            return result;
        }

        public static function stringify(jsonClass:Class, value:Object, replacer:* = null, space:* = null):String{
            var result:String;
            try{
                result = jsonClass.stringify(value, replacer, space);
            }catch (e:Error) {
                result = "";
                FirebaseCrashlytics.service.recordError(e);
                FirebaseCrashlytics.service.setStringValue("stringify", "function");
            }
            return result;
        }
    }
}
